#line 691 "ifupdown.nw"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>
#line 701 "ifupdown.nw"
#include "header.h"
#line 840 "ifupdown.nw"
#include <errno.h>
#line 972 "ifupdown.nw"
#include <ctype.h>
#line 817 "ifupdown.nw"
static int get_line(char **result, size_t *result_len, FILE *f);
#line 1041 "ifupdown.nw"
static char *next_word(char *buf, char *word, int maxlen);
#line 1174 "ifupdown.nw"
static address_family *get_address_family(address_family *af[], char *name);
#line 1209 "ifupdown.nw"
static method *get_method(address_family *af, char *name);
#line 1287 "ifupdown.nw"
static int duplicate_if(interface_defn *ifa, interface_defn *ifb);
#line 765 "ifupdown.nw"
interface_defn *read_interfaces(char *filename) {
	
#line 790 "ifupdown.nw"
FILE *f;
#line 824 "ifupdown.nw"
char *buf = NULL;
size_t buf_len = 0;
#line 1022 "ifupdown.nw"
char scheme[80] = "*";
interface_defn *currif = NULL;
#line 1032 "ifupdown.nw"
char firstword[80];
char *rest;
#line 767 "ifupdown.nw"
	interface_defn *ifaces = NULL;

	
#line 794 "ifupdown.nw"
f = fopen(filename, "r");
if ( f == NULL ) return NULL;

#line 771 "ifupdown.nw"
	while (
#line 832 "ifupdown.nw"
get_line(&buf,&buf_len,f)
#line 771 "ifupdown.nw"
                                             ) {
		
#line 1066 "ifupdown.nw"
rest = next_word(buf, firstword, 80);
if (rest == NULL) continue; /* blank line */

if (strcmp(firstword, "scheme") == 0) {
	
#line 1085 "ifupdown.nw"
rest = next_word(rest, scheme, 80);
if (!rest) {
	
#line 1370 "ifupdown.nw"
fprintf(stderr, "%s: scheme name missing\n", filename);
return NULL;
#line 1088 "ifupdown.nw"
}
#line 1071 "ifupdown.nw"
} else if (strcmp(firstword, "iface") == 0) {
	
#line 1096 "ifupdown.nw"
{
	
#line 1130 "ifupdown.nw"
char iface_name[80];
char address_family_name[80];
char method_name[80];

#line 1099 "ifupdown.nw"
	
#line 1118 "ifupdown.nw"
currif = malloc(sizeof(interface_defn));
if (!currif) {
	
#line 1365 "ifupdown.nw"
perror(filename);
return NULL;
#line 1121 "ifupdown.nw"
}

#line 1101 "ifupdown.nw"
	
#line 1136 "ifupdown.nw"
rest = next_word(rest, iface_name, 80);
rest = next_word(rest, address_family_name, 80);
rest = next_word(rest, method_name, 80);

if (rest == NULL) {
	
#line 1375 "ifupdown.nw"
fprintf(stderr, "%s: too few parameters for iface line\n", filename);
return NULL;
#line 1142 "ifupdown.nw"
}

if (rest[0] != '\0') {
	
#line 1380 "ifupdown.nw"
fprintf(stderr, "%s: too many parameters for iface line\n", filename);
return NULL;
#line 1146 "ifupdown.nw"
}

#line 1103 "ifupdown.nw"
	
#line 1153 "ifupdown.nw"
currif->iface = strdup(iface_name);
if (!currif->iface) {
	
#line 1365 "ifupdown.nw"
perror(filename);
return NULL;
#line 1156 "ifupdown.nw"
}    
#line 1104 "ifupdown.nw"
	
#line 1160 "ifupdown.nw"
currif->scheme = strdup(scheme);
if (!currif->scheme) {
	
#line 1365 "ifupdown.nw"
perror(filename);
return NULL;
#line 1163 "ifupdown.nw"
}
#line 1105 "ifupdown.nw"
	
#line 1178 "ifupdown.nw"
currif->address_family = get_address_family(addr_fams, address_family_name);
if (!currif->address_family) {
	
#line 1385 "ifupdown.nw"
fprintf(stderr, "%s: unknown address type\n", filename);
return NULL;
#line 1181 "ifupdown.nw"
}
#line 1106 "ifupdown.nw"
	
#line 1213 "ifupdown.nw"
currif->method = get_method(currif->address_family, method_name);
if (!currif->method) {
	
#line 1390 "ifupdown.nw"
fprintf(stderr, "%s: unknown method\n", filename);
return NULL;
#line 1216 "ifupdown.nw"
	return NULL; /* FIXME */
}
#line 1107 "ifupdown.nw"
	
#line 1236 "ifupdown.nw"
currif->automatic = 1;
currif->max_options = 0;
currif->n_options = 0;
currif->option = NULL;

#line 1109 "ifupdown.nw"
	
#line 1252 "ifupdown.nw"
currif->next = NULL;

if (ifaces == NULL) {
	ifaces = currif;
} else {
	interface_defn *checkif;
	checkif = ifaces; 
	for(;;) {
		if (duplicate_if(checkif, currif)) {
			
#line 1395 "ifupdown.nw"
fprintf(stderr, "%s: duplicate interface\n", filename);
return NULL;
#line 1262 "ifupdown.nw"
		}
		if (!checkif->next) break;
		checkif = checkif->next;
	}

	checkif->next = currif;
}
#line 1110 "ifupdown.nw"
}
#line 1073 "ifupdown.nw"
} else {
	
#line 1308 "ifupdown.nw"
if (!currif) {
	
#line 1400 "ifupdown.nw"
fprintf(stderr, "%s: option without interface\n", filename);
return NULL;
#line 1310 "ifupdown.nw"
} else {
	if (strcmp(firstword,"noauto") == 0) {
		currif->automatic = 0;
	} else {
		
#line 1324 "ifupdown.nw"
if (currif->n_options >= currif->max_options) {
	
#line 1346 "ifupdown.nw"
{
	variable *opt;
	currif->max_options = currif->max_options + 10;
	opt = realloc(currif->option, sizeof(variable) * currif->max_options);
	if (opt == NULL) {
		
#line 1365 "ifupdown.nw"
perror(filename);
return NULL;
#line 1352 "ifupdown.nw"
	}
	currif->option = opt;
}
#line 1326 "ifupdown.nw"
}

currif->option[currif->n_options].name = strdup(firstword);
currif->option[currif->n_options].value = strdup(rest);

if (!currif->option[currif->n_options].name) {
	
#line 1365 "ifupdown.nw"
perror(filename);
return NULL;
#line 1333 "ifupdown.nw"
}

if (!currif->option[currif->n_options].value) {
	
#line 1365 "ifupdown.nw"
perror(filename);
return NULL;
#line 1337 "ifupdown.nw"
}

currif->n_options++;	
#line 1315 "ifupdown.nw"
	}
}
#line 1075 "ifupdown.nw"
}
#line 773 "ifupdown.nw"
	}
	if (
#line 844 "ifupdown.nw"
errno != 0
#line 774 "ifupdown.nw"
                                           ) {
		
#line 1365 "ifupdown.nw"
perror(filename);
return NULL;
#line 776 "ifupdown.nw"
	}

	
#line 799 "ifupdown.nw"
fclose(f);

#line 780 "ifupdown.nw"
	return ifaces;
}
#line 857 "ifupdown.nw"
static int get_line(char **result, size_t *result_len, FILE *f) {
	
#line 882 "ifupdown.nw"
size_t pos;
#line 859 "ifupdown.nw"
	
	do {
		
#line 889 "ifupdown.nw"
pos = 0;
#line 862 "ifupdown.nw"
		
#line 900 "ifupdown.nw"
do {
	
#line 919 "ifupdown.nw"
if (*result_len - pos < 10) {
	char *newstr = realloc(*result, *result_len * 2 + 80);
	if (newstr == NULL) {
		return 0;
	}
	*result = newstr;
	*result_len = *result_len * 2 + 80;
}
#line 902 "ifupdown.nw"
	
#line 948 "ifupdown.nw"
if (!fgets(*result + pos, *result_len - pos, f)) {
	if (errno == 0 && pos == 0) return 0;
	if (errno != 0) return 0;
}
pos += strlen(*result + pos);
#line 903 "ifupdown.nw"
} while(
#line 939 "ifupdown.nw"
pos == *result_len - 1 && (*result)[pos-1] != '\n'
#line 903 "ifupdown.nw"
                                   );

#line 960 "ifupdown.nw"
if (pos != 0 && (*result)[pos-1] == '\n') {
	(*result)[--pos] = '\0';
}

#line 907 "ifupdown.nw"
assert( (*result)[pos] == '\0' );
#line 863 "ifupdown.nw"
		
#line 976 "ifupdown.nw"
{ 
	int first = 0; 
	while (isspace((*result)[first]) && (*result)[first]) {
		first++;
	}

	memmove(*result, *result + first, pos - first + 1);
	pos -= first;
}
#line 864 "ifupdown.nw"
	} while (
#line 1000 "ifupdown.nw"
(*result)[0] == '#'
#line 864 "ifupdown.nw"
                               );

	while (
#line 1004 "ifupdown.nw"
(*result)[pos-1] == '\\'
#line 866 "ifupdown.nw"
                               ) {
		
#line 1008 "ifupdown.nw"
(*result)[--pos] = '\0';
#line 868 "ifupdown.nw"
		
#line 900 "ifupdown.nw"
do {
	
#line 919 "ifupdown.nw"
if (*result_len - pos < 10) {
	char *newstr = realloc(*result, *result_len * 2 + 80);
	if (newstr == NULL) {
		return 0;
	}
	*result = newstr;
	*result_len = *result_len * 2 + 80;
}
#line 902 "ifupdown.nw"
	
#line 948 "ifupdown.nw"
if (!fgets(*result + pos, *result_len - pos, f)) {
	if (errno == 0 && pos == 0) return 0;
	if (errno != 0) return 0;
}
pos += strlen(*result + pos);
#line 903 "ifupdown.nw"
} while(
#line 939 "ifupdown.nw"
pos == *result_len - 1 && (*result)[pos-1] != '\n'
#line 903 "ifupdown.nw"
                                   );

#line 960 "ifupdown.nw"
if (pos != 0 && (*result)[pos-1] == '\n') {
	(*result)[--pos] = '\0';
}

#line 907 "ifupdown.nw"
assert( (*result)[pos] == '\0' );
#line 869 "ifupdown.nw"
	}

	
#line 988 "ifupdown.nw"
while (isspace((*result)[pos-1])) { /* remove trailing whitespace */
	pos--;
}
(*result)[pos] = '\0';

#line 873 "ifupdown.nw"
	return 1;
}
#line 1045 "ifupdown.nw"
static char *next_word(char *buf, char *word, int maxlen) {
	if (!buf) return NULL;
	if (!*buf) return NULL;

	while(!isspace(*buf) && *buf) {
		if (maxlen-- > 1) *word++ = *buf;
		buf++;
	}
	if (maxlen > 0) *word = '\0';

	while(isspace(*buf) && *buf) buf++;

	return buf;
}
#line 1190 "ifupdown.nw"
static address_family *get_address_family(address_family *af[], char *name) {
	int i;
	for (i = 0; af[i]; i++) {
		if (strcmp(af[i]->name, name) == 0) {
			return af[i];
		}
	}
	return NULL;
}
#line 1221 "ifupdown.nw"
static method *get_method(address_family *af, char *name) {
	int i;
	for (i = 0; i < af->n_methods; i++) {
		if (strcmp(af->method[i].name, name) == 0) {
			return &af->method[i];
		}
	}
	return NULL;
}
#line 1291 "ifupdown.nw"
static int duplicate_if(interface_defn *ifa, interface_defn *ifb) {
	if (strcmp(ifa->scheme, ifb->scheme) != 0) return 0;
	if (strcmp(ifa->iface, ifb->iface) != 0) return 0;
	if (ifa->address_family != ifb->address_family) return 0;
	return 1;
}
