#line 73 "ifupdown.nw"
#ifndef HEADER_H
#define HEADER_H

#line 295 "ifupdown.nw"
typedef struct address_family address_family;
#line 328 "ifupdown.nw"
typedef struct method method;
#line 720 "ifupdown.nw"
typedef struct interface_defn interface_defn;
#line 745 "ifupdown.nw"
typedef struct variable variable;
#line 346 "ifupdown.nw"
typedef int (execfn)(char *command);
typedef int (command_set)(interface_defn *ifd, execfn *e);
#line 299 "ifupdown.nw"
struct address_family {
	char *name;
	int n_methods;
	method *method;
};
#line 332 "ifupdown.nw"
struct method {
	char *name;
	command_set *up, *down;
	int n_options;
	char **option;
};
#line 724 "ifupdown.nw"
struct interface_defn {
	interface_defn *next;

	char *iface;
	char *scheme;
	address_family *address_family;
	method *method;

	int automatic;

	int max_options;
	int n_options;
	variable *option;
};
#line 749 "ifupdown.nw"
struct variable {
	char *name;
	char *value;
};
#line 1599 "ifupdown.nw"
#define MAX_OPT_DEPTH 10
#line 1657 "ifupdown.nw"
#define EUNBALBRACK 10001
#define EUNDEFVAR   10002
#line 1682 "ifupdown.nw"
#define MAX_VARNAME   32
#define EUNBALPER   10000
#line 311 "ifupdown.nw"
extern address_family *addr_fams[];
#line 761 "ifupdown.nw"
interface_defn *read_interfaces(char *filename);
#line 1429 "ifupdown.nw"
int execute(char *command, interface_defn *ifd, execfn *exec);

#line 82 "ifupdown.nw"
#endif /* HEADER_H */
